/* $Id: blas.h,v 1.2 2006/01/18 11:54:29 cvsroot Exp $ */

/* GenLib2 - General Library 2
 * Copyright (C) 2005 Dirk Stallmann
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef GENLIB2_BLAS_INCLUDED
#define GENLIB2_BLAS_INCLUDED

#include "vector.h"
#include "matrix.h"

// external C functions
extern "C"
{
	// copy vector
	void dcopy(int&, double&, int&, double&, int&);

	// dot product
	double ddot(int&, double&, int&, double&, int&);
}

namespace GenLib2
{

/** Cholesky decomposition.
 *  Cholesky decomposition C'C = A. Only for symmetric and
 */
bool lapack_dpotrf(Matrix<double>& A)
{
	bool rtn = true;
	char uplo = 'u';
	int n = A.rows();
	int lda = A.rows();
	int info = 0;

	F77_DPOTRF(uplo, n, A(0,0), lda, info);
	if (info != 0) rtn = false;

	return rtn;
}

} // namespace GenLib2

#endif /* GENLIB2_BLAS_INCLUDED */
